% ALS - Alternating least squares algorithm for low rank approx.
%
% D   - data matrix
% P*L - initial approximation with rank R
% TOL - converhgence tolernace
% DH  - rank-R approximating matrix 
% E   - the sequence ||D - DH(k)||_F^2, k = 1,2,...

function [dh,e] = als(d,p,l,tol,maxiter)

dh = p*l; 
e(1) = norm(d - dh,'fro')^2;
for i = 2:maxiter
    p  = d * l' / (l*l');
    l  = (p'*p) \ p' * d;
    dh_old = dh; dh = p*l;
    e(i) = norm(d - dh,'fro')^2;
    if norm(dh_old - dh,'fro')^2 < tol
        break
    end
end