function [th, sh] = bclra(D, deg)
[q, N] = size(D); qext = nchoosek(q + deg, deg); 
h{1} = @(x) 1; h{2} = @(x) x;
for k = 3:(2 * deg + 1)
  h{k} = @(x) [x * h{k - 1}(x) zeros(1, mod(k - 2, 2))] ...
                  - [0 (k - 2) * h{k - 2}(x)];
end
Deg  = monomials(deg); 
dpsi = ceil((q * deg + 1) / 2); 
psi  = zeros(qext, qext, dpsi);
for i = 1:qext
  for j = 1:qext
    if i >= j 
      Deg_ij = Deg(i, :) + Deg(j, :); 
      for l = 1:N
        psi_ijl = 1;
        for k = 1:q
          psi_ijl  = conv(psi_ijl, h{Deg_ij(k) + 1}(D(k, l)));
        end
        psi_ijl = [psi_ijl zeros(1, dpsi - length(psi_ijl))];
        psi(i, j, :) = psi(i, j, :) + ...
                       reshape(psi_ijl(1:dpsi), 1, 1, dpsi);
      end
    end
  end
end
for k = 1:dpsi, 
  psi(:, :, k) = psi(:, :, k) + triu(psi(:, :, k)', 1); 
end
[evec, ev] = polyeig_(psi); ev(find(ev < 0)) = inf;
[sh2, min_ind]  = min(ev); 
sh = sqrt(sh2); th = evec(:, min_ind); 
