% Simulation parameters
Tmin  = 10; Tmax = 100; % number of data points
np    = 10;  % number of steps in [Tmin, Tmax]
sigma = 0.1; % noise standard deviation
N     = 10;  % number of Monte Carlo repetitions

bar_p = randn(2, 1);         % true model
bar_w = bar_p * randn(1, T); % true data 

TT = round(linspace(Tmin, Tmax, np)); % points to test
E  = zeros(N, np); % matrix of resulting approximation errors
for i = 1:N
    tilde_w = sigma * randn(2, T);
    wd = bar_w + tilde_w;
    for j = 1:np
        [rh, ph, M, wh] = tls(wd(:, 1:TT(j)), 1);
        E(i,j) = dist(bar_p, ph);
    end
end
plot(TT, mean(E, 1), 'linewidth', 2)
print_fig('example-1-f1')
