addpath ~/mfiles/curve-fitting

ax = [0 1 0 1]; q = 2; d = 2; qext = 6; [D, phi] = monomials(d, q);

% example of nonunique conic section fit

N = 4; w = [0.2 0.8 0.2 0.8; 
            0.2 0.2 0.8 0.8]; % w = rand(2, N); 
r    = null(phi(w)');

figure(1), hold on; plot(w(1,:), w(2,:), 'o', 'markersize', 10); 
plot_model(th2poly(r(:, 1), phi), ax, 'LineStyle', '-', 'color', 'r'); 
plot_model(th2poly(r(:, 2), phi), ax, 'LineStyle', '--', 'color', 'b'); 
axis(ax), print_fig('intro-f1')

% example of unique conic section fit

N = 5; w = [0.2 0.8 0.2 0.8 0.9; 
            0.2 0.2 0.8 0.8 0.5]; %w = rand(2, N);
r = null(phi(w)');

figure(2), hold on; plot(w(1,:), w(2,:), 'o', 'markersize', 10); 
plot_model(th2poly(r(:, 1), phi), ax, 'LineStyle', '-', 'color', 'b'); 
axis(ax), print_fig('intro-f2')
