function [ph, info] = nucnrm(tts, p, gamma, nrm, w, s0, g, h)
[m, n] = size(tts); np = max(max(tts));, if ~exist('s0', 'var') | isempty(s0), s0 = zeros(m, n); end
cvx_begin sdp; cvx_quiet(true);
  variable U(n, n) symmetric;
  variable V(m, m) symmetric;
  variables ph(np) nu;
  phext = [0; ph(:)]; dh = s0 + phext(tts + 1);
  minimize( trace(U) / 2 + trace(V) / 2 + gamma * nu );
  subject to
    [U dh'; dh V] > 0; 
    norm(w * (p - ph), nrm) < nu;
    if (nargin > 6) & ~isempty(g), g * ph < h; end
cvx_end
