clear all, close all

% model
d = 2; s = poly_fun(d); 
qext = length(s([1; 2]));
R = [rand(1, qext - 1) -1];

% data
N  = 20;
H  = ezplot(@(x,y) R * s([x y]')); hold on
wb = [];
for h = H'
    wb = [wb [get(h, 'XData'); get(h, 'YData')]]; 
end
wb = wb(:, round(linspace(1, size(wb, 2), N)));
wd = wb + 0.01 * randn(size(wb));

% estimation
[Rh, wh] = nslra(wd, s, qext - 1); 
c = norm(wd - wh, 'fro')

% plot
plot(wd(1,:), wd(2,:), 'o', 'markersize', 7), hold on
ezplot(@(x,y) Rh * s([x y]'));
