function [th, Dh, info] = pslra(D, phi, r, xini)
[q, N] = size(D); nt = size(phi(D), 1);
if (nargin < 4) | isempty(xini)
    tini = lra(phi(D), r); xini = [D(:); tini(:)];
end 
Dh = @(x) reshape(x(1:(q * N)), q, N); 
th = @(x) reshape(x((q * N + 1):end), nt - r, nt)';
prob = optimset(); 
prob.solver = 'fmincon';
prob.options = optimset('disp', 'off'); 
prob.objective = @(x) norm(D - Dh(x), 'fro');
prob.nonlcon   = @(x) deal([], ...
         [th(x)' * phi(Dh(x)), th(x)' * th(x) - eye(nt - r)]);
prob.x0 = xini;
[x, fval, flag, info] = fmincon(prob); info.M = fval; Dh = Dh(x); th = th(x);
