function x = rio2x(r, io, tol)
q = size(r, 2); if ~exist('io') || isempty(io), io = 1:q; end , if ~exist('tol') || isempty(tol), tol = 1e-12; end 
r = minr(r, tol); p = size(r, 1); m = q - p;
Pi = eye(length(io)); Pi = Pi(io,:); , inv_io = (1:length(io)) * Pi;, rpi = r(:, inv_io); 
ru  = rpi(:, 1:m); ry = rpi(:, (m + 1):end);
[u, s, v] = svd(ry); s = diag(s);
if s(end) < tol
    warning('Computation of X is ill conditioned.'); x = NaN;
else 
    x = -( v * diag(1 ./ s) * u' * ru )'; 
end
