function [ph, gamma] = slra_nn(tts, p, r, gamma, nrm, w, s0)
[m, n] = size(tts); np = max(max(tts));, vec_tts = tts(:); NP = 1:np;
                                      bfs = vec_tts(:, ones(1, np)) == NP(ones(m * n, 1), :);, if ~exist('s0', 'var') | isempty(s0), s0 = zeros(m, n); end, if ~exist('w', 'var') | isempty(w), w = eye(np); end
if ~exist('gamma', 'var'), gamma = []; end % default gamma
if ~exist('nrm', 'var'),   nrm = 2;    end % default norm

if ~isempty(gamma) & isscalar(gamma) 
  ph = nucnrm(tts, p, gamma, nrm, w, s0);
else
  if ~isempty(gamma) 
    gamma_min = gamma(1); gamma_max = gamma(2);
  else 
    gamma_min = 0; gamma_max = 100; 
  end
  rel_rank_tol  = 1e-6; abs_rank_tol = 1e-6;
  rel_gamma_tol = 1e-5; maxiter      = 20; 
  iter = 0;
  while ((gamma_max - gamma_min) / gamma_max > rel_gamma_tol) ...
        & (iter < maxiter)
    gamma = (gamma_min + gamma_max) / 2;
    ph = nucnrm(tts, p, gamma, nrm, w, s0);
    sv = svd(ph(tts)); 
    if (sv(r + 1) / sv(1) > rel_rank_tol) ...
      & (sv(1) > abs_rank_tol)
      gamma_max = gamma;
    else
      gamma_min = gamma;
    end       
    iter = iter + 1; 
  end
end
