randn('seed', 0); rand('seed', 0);
sys = c2d(ss(A, B, C, D), ts); G = dcgain(sys); 
[p, m] = size(G); n = size(sys, 'order');
y0 = lsim(sys, u0, [], xini);
y = y0 + randn(T, p) * s; 
uh_dd = stepid_dd(y, G, n, ff);
uh_kf = stepid_kf(y, sys.a, sys.b, sys.c, sys.d, ...
                  s^2 * eye(size(D, 1)));
figure(2 * (exm_n - 1) + 1), hold on, 
if n > 0, Tmin = 2 * n + 1; else Tmin = 2; end, t = Tmin:T;
plot(t, y0(t, :) / G', 'k-'), plot(t, y(t, :) / G', 'k:'), 
plot(t, u0(t, :), 'k--'), plot(t, uh_dd(t, :), '--b'), 
plot(t, uh_kf(t, :), '-.r'), ax = axis; 
axis([Tmin T ax(3:4)]), print_fig(['example-' int2str(exm_n)])
N = 100; clear e_dd e_kf e_nv
for i = 1:N
  y = y0 + randn(T, p) * s;       
  e_nv(:, i) = sum(abs(u0 - y / G'), 2);
  uh_dd = stepid_dd(y, G, n, ff);  
  e_dd(:, i) = sum(abs(u0 - uh_dd), 2);
  uh_kf = stepid_kf(y, sys.a, sys.b, sys.c, sys.d, ...
                    s^2 * eye(size(D, 1))); 
  e_kf(:, i) = sum(abs(u0 - uh_kf), 2);
end
figure(2 * (exm_n - 1) + 2), hold on
plot(t, mean(e_dd(t, :), 2), '--b'), 
plot(t, mean(e_kf(t, :), 2), '-.r'),
plot(t, mean(e_nv(t, :), 2), ':k'), 
ax = axis; axis([Tmin T 0 ax(4)]), 
print_fig(['example-error-' int2str(exm_n)]) 
exm_n = exm_n + 1;
