randn('state', 0), rand('state', 0)
if strcmp(structure, 'Hankel')
    np   = m + n - 1; s = hankel(1:m, m:np); 
    p0   = impulse(drss(r0), np + 1); p0 = p0(2:end); 
else % unstructured
    np = m * n; s = reshape(1:np, m, n);
    p0 = rand(m, r0) * rand(r0, n); p0 = p0(:);
end
e = randn(np, 1); 
p = p0 + nl * e / norm(e) * norm(p0);
[ph, gamma] = slra_nn(p, s, r0); 
if strcmp(structure, 'Hankel')
    sysh = h2ss([0; p], r0); 
    ph2 = impulse(sysh, np + 1); ph2 = ph2(2:end);
    [sysh, info2, ph3] = slraident(p, 0, r0); 
    sv   = [svd(p(s)) svd(ph(s)) svd(ph2(s)) svd(ph3(s))]
    cost = [norm(p - p) norm(p - ph) ...
            norm(p - ph2) norm(p - ph3)]
else % unstructured
    [t1, t2, t3, dh] = lra(p(s)', r0); dh = dh';
    sv = [svd(p(s)) svd(ph(s)) svd(dh)]
    cost = [norm(p - p) norm(p - ph) norm(p - dh(:))]
end
E = []; E_ = [];
for rr = 1:min(m,n) - 1
    ph = slra_nn(p, s, rr); 
    E  = [E  norm(p - ph)];
    if strcmp(structure,'Hankel')
        sysh = h2ss([0;p], rr); 
        ph = impulse(sysh, np + 1); ph = ph(2:end);
    else % unstructured
        if m > n, [t1, t2, t3, dh] = lra(p(s)', rr); dh = dh';
        else      [t1, t2, t3, dh] = lra(p(s), rr);  end
        ph = dh(:);
    end
    E_ = [E_ norm(p - ph)];
end        
plot(E , 1:min(m,n)-1, 'bx', 'markersize', 8), hold on
plot(E_, 1:min(m,n)-1, 'ro', 'markersize', 8)
legend('Nuclear norm','SVD')
plot(E , 1:min(m,n)-1, 'b--', 'linewidth', 1, 'markersize', 8)
plot(E_, 1:min(m,n)-1, 'r-.', 'linewidth', 1, 'markersize', 8)
