randn('seed', 0); rand('seed', 0);
if strcmp(structure, 'hankel')
  np = m + n - 1; tts = hankel(1:m, m:np); 
  p0 = impulse(drss(r0), np + 1); p0 = p0(2:end); 
else % unstructured
  np = m * n; tts = reshape(1:np, m, n);
  p0 = rand(m, r0) * rand(r0, n); p0 = p0(:);
end
e = randn(np, 1); p = p0 + nl * e / norm(e) * norm(p0);
[ph, gamma] = slra_nn(tts, p, r0); 
if strcmp(structure, 'hankel')
  sysh = h2ss([0; p], r0); 
  ph2 = impulse(sysh, np + 1); ph2 = ph2(2:end);
  tts_ = hankel(1:(r0 + 1), (r0 + 1):np);
  [Rh, ph3] = slra(tts_, p, r0); 
  sv = [svd(p(tts)) svd(ph(tts)) svd(ph2(tts)) svd(ph3(tts))]
  cost = [norm(p - p) norm(p - ph) ...
          norm(p - ph2) norm(p - ph3)]
else % unstructured
  [Rh, Ph, dh] = lra(p(tts)', r0); dh = dh';
  sv = [svd(p(tts)) svd(ph(tts)) svd(dh)]
  cost = [norm(p - p) norm(p - ph) norm(p - dh(:))]
end
E = []; E_ = [];
for rr = 1:min(m,n) - 1
  ph = slra_nn(tts, p, rr); E  = [E  norm(p - ph)];
  if strcmp(structure, 'hankel')
    sysh = h2ss([0;p], rr); 
    ph = impulse(sysh, np + 1); ph = ph(2:end);
  else % unstructured
    if m > n, [Rh, Ph, dh] = lra(p(tts)', rr); dh = dh';
    else      [Rh, Ph, dh] = lra(p(tts), rr);  end
    ph = dh(:);
  end
  E_ = [E_ norm(p - ph)];
end        
plot(E , 1:min(m,n)-1, 'bx', 'markersize', 8), hold on
plot(E_, 1:min(m,n)-1, 'ro', 'markersize', 8)
legend('slra_nn','lra')
plot(E , 1:min(m,n)-1, 'b--', 'linewidth', 2, 'markersize', 8)
plot(E_, 1:min(m,n)-1, 'r-.', 'linewidth', 2, 'markersize', 8)
print_fig(structure)
