function sys = w2ss(w, m, l)
    
j = T - l + 1;

% SVD of the Hankel matrix of the data
r   = triu(qr([blkhank(u, l); blkhank(y, l)]'))';
in  = 1:(l * m + l * p);
r11 = r(in, in);
r21 = r(in(end) + 1:end, in);
pinvUY1 = pinv(r11);
Y2      = r21;

% Initialization
fu = zeros(l * m, j); 
fu(1 : l * m, :) = blkhank(u, l, j);
fy = zeros(l * p, j);
fy(1:l * p, :) = blkhank(y, l, j);

% Iteration
maxi = ceil(delta / l);
y0   = zeros(delta * p, j);
for i = 1:maxi
  % Solve the system
  g = pinvUY1 * [fu; fy(1:l*p, :)];
  fy(l*p + 1:end, :) = Y2 * g;
  % Store the result
  y0((i - 1) * l * p + 1:i * l * p, :) = fy(l * p + 1:end,:);
  % Check exit condition (if delta is not given)
  if (find_delta & norm(fy(l*p+1:end,1)) < EPS)
    delta = i;
    break;
  end
  % Shift for the next iteration
  fu(1:m * l, :) = []; 
  fu = [fu; zeros(m * l,j)];
  fy(1:p * l, :) = []; 
  fy = [fy; zeros(p * l, j)]; 
end 

y0 = y0(1:delta * p, :);

% SVD of the matrix of (sequential) free responses 
[U, S ,V] = svd(y0, 0);
s = diag(S);

% Rank revealing factorization
sqrt_s = sqrt(1 . /s(1:n))';
O = sqrt_s(ones(size(U, 1), 1), :) .* U(:, 1:n);
X = (sqrt_s(ones(size(V, 1), 1),:) .* V(:, 1:n))';

% Solve the system of equations for A,B,C,D
M = [x(:, 2:end);   y(1:j, :)'] / ...
    [x(:, 1:end-1); u(1:j, :)'];

a = M(1:n, 1:n);
b = M(1:n, n+1:end);
c = M(n1:end, 1:n);
d = M(n1:end, n1:end);

sys = ss(a, b, c, d, -1);