function [p, l, info] = wlra(d, m, s, opt)
tic, if ~exist('opt.MaxIter'), opt.MaxIter = 100;         end
     if ~exist('opt.TolFun'),  opt.TolFun  = 1e-5;        end
     if ~exist('opt.Display'), opt.Display = 'off';       end
     if ~exist('opt.Method'),  opt.Method  = 'ap';        end 
     if ~exist('opt.alg'),     opt.alg     = 'lsqnonlin'; end 
     if ~exist('opt.P'), p = lra_md(d, m); else p = opt.P, end
switch lower(opt.Method)
case {'altpro', 'ap'} 
  [q, N] = size(d); sd = norm(s .* d, 'fro') ^ 2; 
  cont = 1; k = 0; 
  while (cont)
    dd = []; % vec(D - DH)
    for j = 1:N
      J   = find(s(:, j)); 
      sJj = full(s(J, j));
      c   = sJj .* full(d(J, j));
      P   = sJj(:, ones(1, m)) .* p(J, :); % = diag(sJj) * p(J, :)
      l(:, j) = P \ c; dd = [dd; c - P * l(:, j)];
    end
    ep = norm(dd) ^ 2;
    dd = []; % vec(D - DH)
    for i = 1:q
      I   = find(s(i, :));
      sIi = full(s(i, I));
      r   = sIi .* full(d(i, I));
      L   = sIi(ones(m, 1), :) .* l(:, I); % = l(:, I) * diag(sIi)
      p(i, :) = r / L; dd = [dd, r - p(i, :) * L];
    end
    el = norm(dd) ^ 2;
    k = k + 1; re = abs(el - ep) / el;
    cont = (k < opt.MaxIter) & (re > opt.TolFun) & (el > eps); 
    switch lower(opt.Display)
      case 'iter', 
        fprintf('%2d : relative error = %18.8f\n', k, el / sd)
    end  
  end
  info.err = el; info.iter = k;
case {'varpro', 'vp'}
  switch lower(opt.alg)
    case {'fminunc'} 
      [p, err, f, info] = fminunc(@(p)mwlra(p, d, s), p, opt);
    case {'lsqnonlin'}
      [p, rn, r, f, info] = ...
                    lsqnonlin(@(p)mwlra2(p, d, s), p, [], []);
    otherwise
      error('Unknown algorithm %s.', opt.alg) 
  end
  [info.err, l] = mwlra(p, d, s); % obtain the L parameter
otherwise
  error('Unknown method %s', opt.Method) 
end
info.time = toc; 
